# Studio 6 Questions

# 1. Put your code answering the R questions in this file.
# 2. Read all instructions carefully!
# 3. If code is given with a question it is meant to be used. Don't just ignore it.

# 4. Before uploading the the code: clear your environment and source
#    the entire file (choose source from the code menu).
#   -- Make sure that it runs without error and outputs just the
#     answers asked for in the questions.
#   -- Remember to use print statements to print the values asked for
# 5. **** Upload your code to  ****
#    https://www-math.mit.edu/~dav/uploads/
#
#--------------------------------------
# First, here are the two example functions from studio6NEW.r

studioBeta = function(a,b){ # the two arguments a and b are the "shape
  # parameters" for the distribution.
  x=seq(0,1,.01) # this is a hundred points from 0 to 1, where each beta lives
  mean=a/(a+b) # this is the mean of beta(a,b), from Wikipedia
  variance=a*b/((a+b+1)*(a+b)*(a+b)) # same for variance
  sigma=sqrt(variance) # this is how you get standard deviation from variance
  beta=dbeta(x,a,b) 
  betaplottitle=paste("Beta distn, a =",a,", b =",b)  
  betasubtitle=paste("mean =",format(mean,digits=4),"variance =",
                     format(variance,digits=4))
  plot(x,beta,type="l",ylab = "density",xlab = "",
       sub =betasubtitle,col="red",main = betaplottitle) 
}

studioBinomial = function(N,p){
  x=seq(0,1,1/N) 
  mean=p
  variance=p*(1-p)/N # variance before scaling was N*p*(1-p)
  sigma=sqrt(variance)
  binomialplottitle=paste("Binomial N =",N,", p =",p)
  binomialsubtitle=paste("mean =",format(mean,digits=4),"variance =",
                         format(variance,digits=4))
  binom=dbinom(N*x,N,p)*N 
  plot(x,binom,type="s",ylab="density",xlab="", col="blue",
       main=binomialplottitle,sub = binomialsubtitle)
}

# Problem 1.
# 1(a) Write a function called studioNormal that takes two arguments mu (mean) 
# and sigma (standard deviation) and plots the corresponding normal density
# JUST FROM 0 to 1!

# YOUR CODE for studioNormal HERE.

# add a line like "studioNormal(.7,.2)" showing that your function works.

# 1(b) Experiment with your three functions studioBeta, studioBinomial, and
# studioNormal; TRY TO MAKE THE LAST TWO DRAW CURVES THAT LOOK LIKE 
# THE BETA CURVE.
# Write a statement about what you discovered; something like

# cat("I found that if a and b are both 5, then beta(a,b) looks like\n")
# cat("the normal distribution of mean .5 and variance .151\n")

# But your discovery should be true for LOTS of values of a and b.

#-----
# 1(c) Make a new function that illustrates your discovery,
# by adding a plot of some normal or binomial density to a plot of beta.
# For the stupid discovery above you might write
stupidDiscovery = function(a) {
  if(a==5) {
    studioBeta(5,5) # this makes a plot of beta(5,5)
    x=seq(0,1,.01) # get ready to add the normal density!
    y=dnorm(x,.5,.151) # compute the normal density
    lines(x,y,type="p",col="turquoise") # "lines" says "add to previous plot"
  }
  else cat("Sorry, I don't know anything in this case.\n")
} 
# Look at what happens when you type "stupidDiscovery(5)" in the console.
# What will happen with "stupidDiscovery(7)"?
#--------------------------------------

# YOUR CODE for studioDiscovery HERE.

# add some lines like "studioDiscovery(2,3)" and "studioDiscovery(20,11)"
# which will produce nice plots illustrating your discovery.